/*******************************************************************************************
 *
 *  Definitions used when calling MMBasic Interpreter API Functions from CFunctions
 *  For MMBasic V5.2
 *
 *  This file is public domain and may be used without license.
 *
 *
 ******************************************************************************************/
#define MAXVARLEN           32                      // maximum length of a variable name
#define MAXDIM              5                       // maximum nbr of dimensions to an array
#define MMFLOAT double

//Addresses in the API Table for the pointers to each function

#define Vector_uSec               (*(int*)0x80002a0)       // void uSec(unsigned int us)
#define Vector_putConsole         (*(int*)0x80002a4)       // void putConsole(int c)
#define Vector_getConsole         (*(int*)0x80002a8)       // int getConsole(void)
#define Vector_ExtCfg             (*(int*)0x80002ac)       // void ExtCfg(int pin, int cfg, int option)
#define Vector_ExtSet             (*(int*)0x80002b0)       // void ExtSet(int pin, int val)
#define Vector_ExtInp             (*(int*)0x80002b4)       // int ExtInp(int pin)
#define Vector_PinSetBit          (*(int*)0x80002b8)       // void PinSetBit(int pin, unsigned int offset)
#define Vector_PinRead            (*(int*)0x80002bc)       // int PinRead(int pin)
#define Vector_MMPrintString      (*(int*)0x80002c0)       // void MMPrintString(char* s)
#define Vector_IntToStr           (*(int*)0x80002c4)       // void IntToStr(char *strr, long long int nbr, unsigned int base)
#define Vector_CheckAbort         (*(int*)0x80002c8)       // void CheckAbort(void)
#define Vector_GetMemory          (*(int*)0x80002cc)       // void *GetMemory(size_t msize);
#define Vector_GetTempMemory      (*(int*)0x80002d0)       // void *GetTempMemory(int NbrBytes)
#define Vector_FreeMemory         (*(int*)0x80002d4)       // void FreeMemory(void *addr)
#define Vector_DrawRectangle      *(unsigned int *)(int*)0x80002d8          // void DrawRectangle(int x1, int y1, int x2, int y2, int c)
#define Vector_DrawBitmap         *(unsigned int *)(int*)0x80002dc          // void DrawBitmap(int x1, int y1, int width, int height, int scale, int fg, int bg, unsigned char *bitmap )
#define Vector_DrawLine           (*(int*)0x80002e0)       // void DrawLine(int x1, int y1, int x2, int y2, int w, int c)
#define Vector_FontTable          (*(int*)0x80002e4)       // const unsigned char *FontTable[FONT_NBR]
#define Vector_ExtCurrentConfig   (*(int*)0x80002e8)       // int ExtCurrentConfig[NBRPINS + 1];
#define Vector_HRes               (*(int*)0x80002ec)       // HRes
#define Vector_VRes               (*(int*)0x80002f0)       // VRes
#define Vector_SoftReset          (*(int*)0x80002f4)       // void SoftReset(void)
#define Vector_error              (*(int*)0x80002f8)       // void error(char *msg)
#define Vector_ProgFlash          (*(int*)0x80002fc)       // ProgFlash
#define Vector_vartbl             (*(int*)0x8000300)       // vartbl
#define Vector_varcnt             (*(int*)0x8000304)       // varcnt
#define Vector_DrawBuffer         *(unsigned int *)(int*)0x8000308          // void DrawRectangle(int x1, int y1, int x2, int y2, int c)
#define Vector_ReadBuffer         *(unsigned int *)(int*)0x800030c          // void DrawRectangle(int x1, int y1, int x2, int y2, int c)

//Macros to call each function.

#define CurrentCpuSpeed                 (*(unsigned int *) Vector_CurrentCpuSpeed)
#define uSec(a)                         ((void (*)(unsigned int )) Vector_uSec) (a)
#define putConsole(a)                    ((void (*)(char)) Vector_putConsole) (a)
#define getConsole()                    ((int (*)(void)) Vector_getConsole) ()
#define ExtCfg(a,b,c)                   ((void (*)(int, int, int)) Vector_ExtCfg) (a,b,c)
#define ExtSet(a,b)                     ((void(*)(int, int)) Vector_ExtSet) (a,b)
#define ExtInp(a)                       ((int(*)(int)) Vector_ExtInp) (a)
#define PinSetBit(a,b)                  ((void(*)(int, int)) Vector_PinSetBit) (a,b)
#define PinRead(a)                      ((int(*)(int)) Vector_PinRead) (a)
#define GetPortAddr(a,b)                ((volatile unsigned int * (*)(int,int)) Vector_GetPortAddr) (a,b)
#define GetPinBit(a)                    ((int (*)(int)) Vector_GetPinBit) (a)
#define MMPrintString(a)                ((void (*)(char*)) Vector_MMPrintString) (a)
#define IntToStr(a,b,c)                 ((void (*)(char *, long long int, unsigned int)) Vector_IntToStr) (a,b,c)
#define FloatToStr(a,b,c,d,e)           ((void (*)(char *, float, int, int, char)) Vector_FloatToStr) (a,b,c,d,e)
#define CheckAbort()                    ((void (*)(void)) Vector_CheckAbort) ()
#define GetMemory(a)                    ((void* (*)(int)) Vector_GetMemory) (a)
#define GetTempMemory(a)                ((void* (*)(int)) Vector_GetTempMemory) (a)
#define FreeMemory(a)                   ((void (*)(void *)) Vector_FreeMemory) (a)
#define DrawRectangle(a,b,c,d,e)        ((void (*)(int,int,int,int,int)) (*(unsigned int *)Vector_DrawRectangle)) (a,b,c,d,e)
#define DrawRectangleVector             (*(unsigned int *)Vector_DrawRectangle)
#define DrawBitmap(a,b,c,d,e,f,g,h)     ((void (*)(int,int,int,int,int,int,int, char*)) (*(unsigned int *)Vector_DrawBitmap)) (a,b,c,d,e,f,g,h)
#define DrawBitmapVector                (*(unsigned int *)Vector_DrawBitmap)
#define DrawLine(a,b,c,d,e,f)           ((void (*)(int,int,int,int,int,int)) Vector_DrawLine) (a,b,c,d,e,f)
#define FontTable                       (void*)((int*)(Vector_FontTable))
#define FMul(a,b)                       ((float (*)(float, float)) Vector_FMul) (a,b)
#define FAdd(a,b)                       ((float (*)(float, float)) Vector_FAdd) (a,b)
#define FSub(a,b)                       ((float (*)(float, float)) Vector_FSub) (a,b)
#define FDiv(a,b)                       ((float (*)(float, float)) Vector_FDiv) (a,b)
#define FCmp(a,b)                       ((int (*)(float, float)) Vector_FCmp) (a,b)
#define FSin(a)                         ((float (*)(float)) Vector_FSin) (a)
#define FLog(a)                         ((float (*)(float)) Vector_FLog) (a)
#define FPow(a,b)                       ((float (*)(float, float)) Vector_FPow) (a,b)
#define atanf(a)                        ((float (*)(float)) Vector_atanf) (a)
#define FloatToInt(a)                   ((long long (*)(float)) Vector_FloatToInt) (a)
#define IntToFloat(a)                   ((float (*)(long long)) Vector_IntToFloat) (a)
#define CFuncmSec                       (*(unsigned int *) Vector_CFuncmSec)
#define ExtCurrentConfig                ((int *) Vector_ExtCurrentConfig)
#define CFuncRam                        ((int *) Vector_CFuncRam)
#define Option                          ({struct option_s *optionstructurepointer; optionstructurepointer=(void *)(unsigned int)Vector_Option;})
#define HRes                            (*(unsigned int *) Vector_HRes)
#define VRes                            (*(unsigned int *) Vector_VRes)
#define LoadFloat(a)                    ((float (*)(unsigned int)) Vector_LoadFloat) (a)
#define SoftReset()                     ((void (*)(void)) Vector_SoftReset) ()
#define CFuncInt                        (*(unsigned int *) Vector_CFuncInt)
#define ScrollLCD(a)                    ((void (*)(int)) (*(unsigned int *)Vector_ScrollLCD)) (a)
#define ScrollLCDVector                 (*(unsigned int *)Vector_ScrollLCD)
#define CFuncT1                         (*(unsigned int *) Vector_CFuncT1)
#define CFuncT5                         (*(unsigned int *) Vector_CFuncT5)
// NOTE:  The argument to RunBasicSub is a string specifying the name of the BASIC subroutine to be executed.
//        It MUST be terminated with TWO null chars.
#define RunBasicSub(a)                  ((void (*)(char *)) Vector_ExecuteProgram) (a)

#define SaveProgramToFlash(a,b)         ((void (*)(char *, int)) Vector_SaveProgramToFlash) (a,b)
#define error(a)                        ((void (*)(char *)) Vector_error) (a)
#define ProgFlash                       ((int *) Vector_ProgFlash)
#define ClearProgram()                  ((void (*)(void)) Vector_ClearProgram) ()
#define llist(a,b)                      ((char * (*)(char *, char *)) Vector_llist) (a,b)
#define CFuncInt2                       (*(unsigned int *) Vector_CFuncInt2)
#define GetTouchAxisVector              (*(unsigned int *)Vector_GetTouchAxis)
#define GetTouchAxis                    ((int (*)(int)) (*(unsigned int *)GetTouchAxisVector)) (a)
#define DrawBuffer(a,b,c,d,e)           ((void (*)(int,int,int,int,char *)) (*(unsigned int *)Vector_DrawBuffer)) (a,b,c,d,e)
#define DrawBufferVector                (*(unsigned int *)Vector_DrawBuffer)
#define ReadBuffer(a,b,c,d,e)           ((void (*)(int,int,int,int,char *)) (*(unsigned int *)Vector_ReadBuffer)) (a,b,c,d,e)
#define ReadBufferVector                (*(unsigned int *)Vector_ReadBuffer)

// the structure of the variable table, passed to the CFunction as a pointer Vector_vartbl which is #defined as vartbl
struct s_vartbl {                               // structure of the variable table
	char name[MAXVARLEN];                       // variable's name
    char type;                                  // its type (T_NUM, T_INT or T_STR)
    char level;                                 // its subroutine or function level (used to track local variables)
    unsigned char size;                         // the number of chars to allocate for each element in a string array
    char dummy;
    int __attribute__ ((aligned (4))) dims[MAXDIM];                     // the dimensions. it is an array if the first dimension is NOT zero
    union u_val{
        MMFLOAT f;                              // the value if it is a float
        long long int i;                        // the value if it is an integer
        MMFLOAT *fa;                            // pointer to the allocated memory if it is an array of floats
        long long int *ia;                      // pointer to the allocated memory if it is an array of integers
        char *s;                                // pointer to the allocated memory if it is a string
    }  __attribute__ ((aligned (8))) val;
} __attribute__ ((aligned (8))) val;

// the variable table
#define vartbl                          (*(struct s_vartbl *) Vector_vartbl)

// number of variables defined (eg, largest index into the variable table)
#define varcnt                          (*(unsigned int *) Vector_varcnt)


//  Useful macros


// Types used to define a variable in the variable table (vartbl).   Often they are ORed together.
// Also used in tokens and arguments to functions
#define T_NOTYPE       0                            // type not set or discovered
#define T_NBR       0x01                            // number (or float) type
#define T_STR       0x02                            // string type
#define T_INT       0x04                            // 64 bit integer type
#define T_PTR       0x08                            // the variable points to another variable's data
#define T_IMPLIED   0x10                            // the variables type does not have to be specified with a suffix
#define T_CONST     0x20                            // the contents of this variable cannot be changed


//***************************************************************************************************
// Constants and definitions copied from the Micromite MkII and Micromite Plus source
//***************************************************************************************************

//The Option structure
struct option_s {
    char Autorun;
    char Tab;
    char Invert;
    char Listcase;
// 4
    int  dummyint;
    unsigned int  PIN;
    unsigned int  Baudrate;
    int DefaultFC, DefaultBC;      // the default colours
    int DISPLAY_WIDTH;
    int DISPLAY_HEIGHT;
// 32
    short RTC_Calibrate;
    volatile unsigned short USBPolling;
// 36
    char Height;
    char Width;
    char Console;
    char DefaultFont;
// 40
    char SerialPullup;
    char fulltime;
    char USBKeyboard;
    signed char colourmode;
// 44
    unsigned char showstatus;
    char colourmap;
    char SDspeed;
    unsigned char editfont;
// 48
    unsigned char F11Key[24];
    unsigned char F12Key[24];
// 96
    unsigned int rtcdrive;
// 100
	short RepeatStart;
	short RepeatRate;
	unsigned char path[24];
// 128
};


// Define the offsets from the PORT address
// these are used by GetPortAddr(a,b)
#define ANSEL               -8
#define ANSELCLR            -7
#define ANSELSET            -6
#define ANSELINV            -5
#define TRIS                -4
#define TRISCLR             -3
#define TRISSET             -2
#define TRISINV             -1
#define PORT                0
#define PORTCLR             1
#define PORTSET             2
#define PORTINV             3
#define LAT                 4
#define LATCLR              5
#define LATSET              6
#define LATINV              7
#define ODC                 8
#define ODCCLR              9
#define ODCSET              10
#define ODCINV              11
#define CNPU                12
#define CNPUCLR             13
#define CNPUSET             14
#define CNPUINV             15
#define CNPD                16
#define CNPDCLR             17
#define CNPDSET             18
#define CNPDINV             19
#define CNCON               20
#define CNCONCLR            21
#define CNCONSET            22
#define CNCONINV            23
#define CNEN                24
#define CNENCLR             25
#define CNENSET             26
#define CNENINV             27
#define CNSTAT              28
#define CNSTATCLR           29
#define CNSTATSET           30
#define CNSTATINV           31

// configurations for an I/O pin
// these are used by ExtCfg(a,b,c)
#define EXT_NOT_CONFIG      0       // Not Configured
#define EXT_ANA_IN          1       // Analogue Input
#define EXT_DIG_IN          2       // Digital Input
#define EXT_FREQ_IN         3       // Frequency Measurement Input
#define EXT_PER_IN          4       // Period measurement Input
#define EXT_CNT_IN          5       // Pulse Counting Input
#define EXT_INT_HI          6       // Generate Interrupt on RISING edge
#define EXT_INT_LO          7       // Generate Interrupt on FALLING edge
#define EXT_DIG_OUT         8       // Digital Output
#define EXT_OC_OUT          9       // Digital Output with Open Collector
#define EXT_INT_BOTH        10      // Generate Interrupt on BOTH Falling and Rising edges
#define EXT_RESERVED        100     // this pin is reserved and SETPIN and PIN cannot be used
#define EXT_BOOT_RESERVED   101     // this pin is reserved at boot

